# 在下项目中使用 PBR 渲染

## 文件准备

* .env 文件
  * 环境光照纹理 (pi_babylon\resources\studio.env)
  * 拷贝到项目文件夹 - 任意目录 (作为资源使用)
  * 修改构建配置
    * res.json 中 添加 `"*/**/*.env",` 项
      * 确保被构建
    * game_env.js 的 loadRes 下 res_suffixs 配置中添加 `"env"` 项
      * 确保被加载
* environmentbrdf_BRDF.png 
  * BRDF 数据纹理 (pi_babylon\resources\environmentbrdf_BRDF.png)
  * 拷贝到项目场景资源目录 - 保证构建时是直接拷贝到构建目录

## 项目渲染相关代码

* 初始化 BABYLON 引擎时
  * ```typescript
    SceneManager.init(canvas, undefined, true); // 确保传入第三个参数 true
    // ...
    registPBR(); // 确保注册PBR相关内容
  ```
* 初始化 使用 PBR 的场景时
  * ```typescript
    // 使用 BRDF 数据纹理
    scene.applyEnvironmentBRDFTexture("app/scene_res/res/environmentbrdf_BRDF.png"); // 注意修改路径
    // 使用 env 数据纹理
    scene.impl.environmentTexture = new BABYLON.CubeTexture(null, scene.impl);
    (<BABYLON.CubeTexture>scene.impl.environmentTexture).updateURL("app/scene_res/studio.env"); // 注意修改路径
    scene.impl.environmentTexture.gammaSpace = false;
  ```
