import { EntityID } from "./entity";
import { IVector3 } from "./math";

export interface IPickInfo {
    rayID: EntityID,
    sphere?: {
        center?: [number, number, number],
        radius: number,
    },
    box?: {
        center?: [number, number, number],
        extends: [number, number, number],
    },
    cylinder?: {
        center?: [number, number, number],
        height: number,
        radius: number,
    }
}

export interface IBoxCollider {
    center: IVector3;
    extend: IVector3;
}

export interface INodeCollider {
    collider?: IBoxCollider;
    isPickable: boolean;
}
