import { IQuaternion, IVector3 } from "./math";
import { IDisposable } from "./base";

export interface INodePostion {
    position: IVector3,
}

export interface INodeEuler {
    rotation: IVector3,
}

export interface INodeScaling {
    scaling: IVector3,
}

export interface INodeRotation {
    rotationQuaternion: IQuaternion,
}

export interface INode {
    _scene: any; // IScene,
    parent: INode,
    // enable: boolean,
    setEnabled(val: boolean): void;
    isEnabled(): boolean;
    isDisposed(): boolean;
}

export interface IIsometryNode extends IDisposable, INode, INodeEuler, INodeRotation, INodePostion {
    lookAt(target: IVector3): void;
}
