import { IDisposable } from "./base";
import { IMesh, IMeshRenderQueue } from "./mesh";

export interface IParticleSystem extends IDisposable {
    isPlaying(): boolean;
    speedRatio: number;
}

export interface IMeshParticleSystemBatch {
    active(particlesys: IMeshParticleSystem): void;
    remove(particlesys: IMeshParticleSystem): void;
    _dirty: boolean;
    _update(): void;
    disposeParticleSystem(particlesys: IMeshParticleSystem): void;
    setSourceMesh(mesh: IMesh): void;
}

export interface IMeshParticleSystem extends IMeshRenderQueue {
    particleSysId: number;
}

export interface IMeshParticleSystemScene {
    getParticleSystemBatche(key: string): IMeshParticleSystemBatch;
}