import { GlContext, IDisposable, ITempFrameBuffer } from "./base";
import { ICamera } from "./camera";
import { IPostprocessParam } from "./postprocess";
import { IPrefabPool } from "./modelprefab";

export interface IScene extends IDisposable {
    isDisposed: boolean;
}

export interface ICustomScene {
    readonly prefabPool: IPrefabPool;
    readonly camera: ICamera;
    readonly renderWidth: number;
    readonly renderHeight: number;
    renderQuality: number;
    resize(width: number, height: number): void;
    render(ctx: GlContext, target?: ITempFrameBuffer, postprocess?: IPostprocessParam[]): boolean;
}
