export type EAtlasRenderBase = 0;
export type EAtlasRenderHSB = 1;
export type EAtlasRenderHS = 2;
export type EAtlasRenderOverlay = 3;
export type EAtlasRenderProgress = 4;
export type EAtlasRenderProgressCircle = 5;
export type EAtlasRenderAlphaEdge = 6;
export type EAtlasRenderMode = EAtlasRenderBase | EAtlasRenderHSB | EAtlasRenderHS | EAtlasRenderOverlay | EAtlasRenderProgress | EAtlasRenderProgressCircle | EAtlasRenderAlphaEdge;
export interface ITexturePackFrame {
    frame: { x: number, y: number, w: number, h: number },
    rotated: boolean,
    trimmed: boolean,
    spriteSourceSize: { x: number, y: number, w: number, h: number },
    sourceSize: { w: number, h: number }
}

export interface ITexturePackAtlas {
    frames: {
        [index: string]: ITexturePackFrame,
    },
    animations?: {
        [index: string]: string[],
    },
    meta: {
        app: "https://www.codeandweb.com/texturepacker" | string,
        version: string,
        image: string,
        format: string,
        size: { w: number, h: number },
        smartupdate: string,
    },
    image: string;
    samplerMode?: number;
    alphaMode?: number;
    noMipmap?: boolean;
    renderMode?: EAtlasRenderMode | number;
    isInvertY?: boolean;
    scale?: [number, number],
}

export type ITexturePackFrameCompact = [number, number, number, number, number, number, number, number, number, number, number, number,];

export interface ITexturePackAtlasCompact {
    frames: {
        [index: string]: ITexturePackFrameCompact,
    },
    animations?: {
        [index: string]: string[],
    },
    meta: {
        app: "https://www.codeandweb.com/texturepacker" | string,
        version: string,
        image: string,
        format: string,
        size: { w: number, h: number },
        smartupdate: string,
    },
    image: string;
    samplerMode?: number;
    alphaMode?: number;
    noMipmap?: boolean;
    compact?: boolean;
    renderMode?: EAtlasRenderMode;
    isInvertY?: boolean;
    scale?: [number, number],
}