
import { IParticle } from "../particle_base";
import { Color4Interpolate, IParticleModifier, ScalingInterpolate, TempColor4A, TempVector3A, TranslationInterpolate } from "./base";

export class ColorBySpeed extends Color4Interpolate implements IParticleModifier {
    private _rangeX: number = 0;
    public set rangeX(value: number) {
        this._rangeX = value;
        this._rangeSize = this._rangeY - this._rangeX;
    }
    public get rangeX() {
        return this._rangeX;
    }
    private _rangeY: number = 1;
    public set rangeY(value: number) {
        this._rangeY = value;
        this._rangeSize = this._rangeY - this._rangeX;
    }
    public get rangeY() {
        return this._rangeY;
    }
    public _rangeSize: number = 1;
    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let localResult = TempColor4A;
        amount = Math.min(1, Math.max(0, (particle.directionLength - this._rangeX) / this._rangeSize));
        this.compute(amount, localResult, particle.colorOverLifetimeAmount);

        particle.color.multiplyToRef(localResult, particle.color);
    }
}