
import { IParticle } from "../particle_base";
import { interpolateThree, interpolateTranslationNoAxis, IParticleModifier, TempVector3A, transformVectorAsLocalSpace, transformVectorAsWorldSpace, TranslationInterpolate } from "./base";

export class ForceOverLifetime extends TranslationInterpolate implements IParticleModifier {
    private _isLocalSpace: boolean = true;
    public set isLocalSpace(value: boolean) {
        if (this._isLocalSpace !== value) {
            this._isLocalSpace = value;
            if (value) {
                this.transformForce = transformVectorAsLocalSpace;
            } else {
                this.transformForce = transformVectorAsWorldSpace;
            }
        }
    }
    public get isLocalSpace() {
        return this._isLocalSpace;
    }

    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let localForce = TempVector3A;

        this.compute(amount, particle.baseRandom, particle.startWorldMatrixInvert, localForce);

        localForce.scaleInPlace(deltaSeconds);

        particle.direction.addInPlace(localForce);
    }
}