
import { IParticle } from "../particle_base";
import { IParticleModifier } from "./base";
import { FloatInterpolation } from "../interpolation";

export class LimitVelocityOverLifetime implements IParticleModifier {
    constructor(
        public interpolation: FloatInterpolation,
        public dampen: number = 0.0
    ) {
        //
    }

    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let localResult = this.interpolation.interpolate(amount, particle.baseRandom[0]);

        let currLength = particle.directionLength;
        particle.directionScale = 1.;
        if (currLength > localResult) {
            particle.direction.scaleInPlace(1.0 - this.dampen * (currLength - localResult) / currLength * (0.66));
            let val = 1.0 - this.dampen * (currLength - localResult) / currLength;
            particle.directionScale = val * val;
        }
    }
}