
import { IParticle } from "../particle_base";
import { IParticleModifier, RotationInterpolate, TempVector3A, TranslationInterpolate } from "./base";

export class RotationOverLifetime extends RotationInterpolate implements IParticleModifier {
    modify(particle: IParticle, amount: number, deltaSeconds: number) {
        let localResult = TempVector3A;

        this.compute(amount, particle.baseRandom, localResult);

        localResult.scaleInPlace(deltaSeconds);

        particle.rotation.addInPlace(localResult);
    }
}