
import { GlitchBlockOffset } from "./glitch_block_offset";
import { RenderTarget, RenderTexture } from "./render_target";
import { ShaderCompiler } from "./shader_compiler";

export class AnimeGlitchBlockOffset extends GlitchBlockOffset {
    public get progress() {
        return this.time;
    }
    public set progress(value: number) {
        this.time = value;
    }
    private animtime: number = 1000;
    private starttime: number = Date.now();
    private isLoop: boolean = true;
    public anime(isLoop: boolean, time: number) {
        this.isLoop = isLoop;
        this.animtime = time * 1000;
        this.starttime = Date.now();

        this.progress = 0;
    }
    public apply(sources: RenderTexture[], target: RenderTarget): ShaderCompiler {
        let progress = (Date.now() - this.starttime) / this.animtime;
        // progress *= progress;
        if (this.isLoop) {
            this.progress = progress;
        }
        else {
            this.progress = progress;
        }

        return super.apply(sources, target);
    }
}