import { GlitchImageBlock } from "./glitch_image_block";
import { RenderTarget, RenderTexture } from "./render_target";
import { ShaderCompiler } from "./shader_compiler";

export class AnimeGlitchImageBlock extends GlitchImageBlock {
    public get progress() {
        return this.time;
    }
    public set progress(value: number) {
        this.time = value;
        this.blockSizeX = 100 * value;
        this.blockSizeY = 400 * value;
        this.cutoff = Math.max(0.0, Math.min(1.0, 1.0 - value));
    }
    private animtime: number = 1000;
    private starttime: number = Date.now();
    private isLoop: boolean = true;
    public anime(isLoop: boolean, time: number) {
        this.isLoop = isLoop;
        this.animtime = time * 1000;
        this.starttime = Date.now();

        this.progress = 0;
    }
    public apply(sources: RenderTexture[], target: RenderTarget): ShaderCompiler {
        let progress = (Date.now() - this.starttime) % this.animtime / this.animtime;
        progress *= progress;
        if (this.isLoop) {
            this.progress = progress % 1;
        }
        else {
            this.progress = 1.0;
        }

        return super.apply(sources, target);
    }
}