import { BABYLON } from '../babylon';

export const initAnimation = () => {
    /**
     * Sets the key frames of the animation
     * @param values The animation key frames to set
     */
    // tslint:disable-next-line:typedef
    BABYLON.Animation.prototype.setKeys = function (values) {
        this._keys = values;
    };

    // 扩展动画数据获取方法
    BABYLON.Animation.prototype._getKeyValue = function(value: any) {
            if (typeof value === "function") {
                return value();
            }

            if (value.clone) {
                return value.clone();
            }
    
            return value;
    }
};