import { BABYLON } from '../babylon';

export interface PiBABYLONGeometry extends BABYLON.Geometry {
    attrsOKListen: Function[];
    attrsOK: boolean;
    attrsOKCall(): void;
    addAttrsOKListen(func: Function): void;
}

export const initGeometry = () => {

    /**
     * 网格数据属性流处理为异步 - 第二次请求同一个Geometry需等待属性流处理结束
     */
    (<PiBABYLONGeometry>BABYLON.Geometry.prototype).attrsOKListen = [];
    (<PiBABYLONGeometry>BABYLON.Geometry.prototype).attrsOK = false;
    (<PiBABYLONGeometry>BABYLON.Geometry.prototype).attrsOKCall = function() {
        this.attrsOK = true;
        this.attrsOKListen.forEach((func: Function) => {
            func && func();
        });
    };
    (<PiBABYLONGeometry>BABYLON.Geometry.prototype).addAttrsOKListen = function(func: Function) {
        if (this.attrsOK) {
            func && func();
        } else {
            this.attrsOKListen.push(func);
        }
    };
    // BABYLON.Geometry.prototype.dispose = function(this: BABYLON.Geometry) {
    //     let scene = this.getScene();
    //     if ((<Scene>scene)?.loader.geometryMap.get(this.id)) {
    //         (<Scene>scene)?.loader.releaseGeometry(this.id);
    //     // 可能纯手动创建,非加载
    //     } else {
    //         const thisgeo: any = this;

    //         const meshes = thisgeo._meshes;
    //         const numOfMeshes = meshes.length;
    //         let index;
    //         for (index = 0; index < numOfMeshes; index++) {
    //             thisgeo.releaseForMesh(meshes[index]);
    //         }
    //         thisgeo._meshes = [];
    //         thisgeo._disposeVertexArrayObjects();
    //         for (const kind in thisgeo._vertexBuffers) {
    //             thisgeo._vertexBuffers[kind].dispose();
    //         }
    //         thisgeo._vertexBuffers = {};
    //         thisgeo._totalVertices = 0;
    //         if (thisgeo._indexBuffer) {
    //             thisgeo._engine._releaseBuffer(thisgeo._indexBuffer);
    //         }
    //         thisgeo._indexBuffer = null;
    //         thisgeo._indices = [];
    //         thisgeo.delayLoadState = BABYLON.Engine.DELAYLOADSTATE_NONE;
    //         thisgeo.delayLoadingFile = null;
    //         thisgeo._delayLoadingFunction = null;
    //         thisgeo._delayInfo = [];
    //         thisgeo._boundingInfo = null;
    //         thisgeo._scene.removeGeometry(thisgeo);
    //         thisgeo._isDisposed = true;
    //     }
    // };

};