import { BABYLON } from "../babylon";
import { AnimationGroup } from "./animation_group";
import { GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW, IAnimationChannel } from "./gltf_loader";
import { IAnimation } from "../../gltf/glTF2Interface";
import { GLTFLoader } from "../../gltf/glTFLoader";
import { ETempNodeAnimationDataKey } from "../../gltf/base";
import { StandardMaterialMesh } from "../../material/standardmaterial";

export function initGLTFLoadAnimaitonChannelNew() {
    // "translation", "rotation", "scale",
    // "uScale", "vScale", "uOffset", "vOffset",
    // "alpha", "color",
    // "ort", "per", "piIsActive", "rotation_eular",
    // "intensity", "lightdiffuse", "alphaCutOff", "cellId",
    // "uScaleOp", "vScaleOp", "uOffsetOp", "vOffsetOp",
    const translation = 0;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[translation]     = _translation;
    const rotation = 1;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[rotation]        = _rotation;
    const scale = 2;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[scale]           = _scale;
    const uScale = 3;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[uScale]          = _uScale;
    const vScale = 4;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[vScale]          = _vScale;
    const uOffset = 5;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[uOffset]         = _uOffset;
    const vOffset = 6;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[vOffset]         = _vOffset;
    const alpha = 7;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[alpha]           = _alpha;
    const color = 8;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[color]           = _color;
    const ort = 9;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[ort]             = _ort;
    const per = 10;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[per]             = _per;
    const piIsActive = 11;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[piIsActive]      = _piIsActive;
    const rotation_eular = 12;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[rotation_eular]  = _rotation_eular;
    const intensity = 13;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[intensity]       = _intensity;
    const lightdiffuse = 14;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[lightdiffuse]    = _lightdiffuse;
    const alphaCutOff = 15;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[alphaCutOff]     = _alphaCutOff;
    const cellId = 16;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[cellId]          = _cellId;
    const uScaleOp = 17;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[uScaleOp]        = _uScaleOp;
    const vScaleOp = 18;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[vScaleOp]        = _vScaleOp;
    const uOffsetOp = 19;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[uOffsetOp]       = _uOffsetOp;
    const vOffsetOp = 20;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[vOffsetOp]       = _vOffsetOp;
    const maskCutoff = 21;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[maskCutoff]      = _maskCutoff;
    const uScaleM = 22;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[uScaleM]        = _uScaleM;
    const vScaleM = 23;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[vScaleM]        = _vScaleM;
    const uOffsetM = 24;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[uOffsetM]       = _uOffsetM;
    const vOffsetM = 25;
    GLTF_LOAD_ANIMATION_CHANNEL_ASYNC_LIST_NEW[vOffsetM]       = _vOffsetM;
}

// Transformnode About
function _transformNode(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup, targetPath: string, animationType: number) {

    let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
    let targetNode = animeAbout[ETempNodeAnimationDataKey.Node];

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
        const animationName = `${babylonAnimationGroup.name}_channel${babylonAnimationGroup.targetedAnimations.length}`;
        const babylonAnimation = new BABYLON.Animation(animationName, targetPath, 1, animationType);
        babylonAnimation.setKeys(keys.link);
        (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);

        if (targetNode) {
            // tslint:disable-next-line:no-non-null-assertion
            const babylonAnimationTargets = [targetNode];
            for (const babylonAnimationTarget of babylonAnimationTargets) {
                babylonAnimationTarget.animations.push(babylonAnimation);
            }
            babylonAnimationGroup.addTargetedAnimation(babylonAnimation, babylonAnimationTargets);
        }
        // else {
        //     if (targetNode.skin < 0 || targetNode.skin === undefined) {
        //         // tslint:disable-next-line:no-non-null-assertion
        //         targetNode._babylonTransformNode!.animations.push(babylonAnimation);
        //         babylonAnimationGroup.addTargetedAnimation(babylonAnimation, targetNode._babylonTransformNode);
        //     }
        // }
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
}
function _mesh(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup, propPath: string, targetPath: string, animationType: number) {

    let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
    let targetNode = <StandardMaterialMesh[]>animeAbout[ETempNodeAnimationDataKey.Mesh];

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
        const animationName = `${babylonAnimationGroup.name}_channel${babylonAnimationGroup.targetedAnimations.length}`;
        const babylonAnimation = new BABYLON.Animation(animationName, propPath, 1, animationType);
        babylonAnimation.setKeys(keys.link);
        (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);

        if (targetNode) {
            // tslint:disable-next-line:no-non-null-assertion
            const babylonAnimationTargets = [];
            for (const babylonAnimationTarget of targetNode) {
                let target = babylonAnimationTarget.materialData || babylonAnimationTarget.material;
                if (!target.animations) {
                    target.animations = [];
                }

                target.animations.push(babylonAnimation);
                babylonAnimationTargets.push(target);
            }
            babylonAnimationGroup.addTargetedAnimation(babylonAnimation, babylonAnimationTargets);
        }
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
    // return _material(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'alpha', 'alpha', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _meshTexture(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup, texturePropPath: string, propPath: string, targetPath: string, animationType: number) {

    let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
    let targetNode = <StandardMaterialMesh[]>animeAbout[ETempNodeAnimationDataKey.Mesh];

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
        const animationName = `${babylonAnimationGroup.name}_channel${babylonAnimationGroup.targetedAnimations.length}`;
        const babylonAnimation = new BABYLON.Animation(animationName, propPath, 1, animationType);
        babylonAnimation.setKeys(keys.link);
        (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);

        if (targetNode) {
            // tslint:disable-next-line:no-non-null-assertion
            const babylonAnimationTargets = [];
            for (const node of targetNode) {
                let target = node.materialData || node.material;
                const texture = target[texturePropPath];
                let sameNameIndex = texture.animations.findIndex((v) => {
                    return v.name == animationName;
                });
                if (sameNameIndex >= 0) {
                    // No thing
                } else {
                    babylonAnimationTargets.push(texture);
                    const babylonAnimation = new BABYLON.Animation(animationName, propPath, 1, animationType);
                    babylonAnimation.setKeys(keys.link);
                    (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);
                    texture.animations.push(babylonAnimation);
                    babylonAnimationGroup.addTargetedAnimation(babylonAnimation, babylonAnimationTargets);
                }
            }
        }
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
    // return _material(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'alpha', 'alpha', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _translation(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _transformNode(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'position', BABYLON.Animation.ANIMATIONTYPE_VECTOR3);
}
function _rotation(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _transformNode(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'rotationQuaternion', BABYLON.Animation.ANIMATIONTYPE_QUATERNION);
}
function _scale(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _transformNode(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'scaling', BABYLON.Animation.ANIMATIONTYPE_VECTOR3);
}
function _piIsActive(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _transformNode(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'piIsActive', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _rotation_eular(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _transformNode(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'rotation', BABYLON.Animation.ANIMATIONTYPE_VECTOR3);
}
function _cellId(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _transformNode(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'cellId', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}

// Material About
function _material(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup, propPath: string, targetPath: string, animationType: number) {
    let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
    let materials = animeAbout[ETempNodeAnimationDataKey.Material];

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
        materials.forEach((mat) => {
            const animationName = `${babylonAnimationGroup.name}_channel${targetPath}`;
            // let mat = mesh.material;
            // if (!mat && mesh._children) {
            //     let target = mesh._children[0];
            //     if (target && (<any>target).source) {
            //         mat = (<any>target).source.material;
            //     } else {
            //         mat = target?.material;
            //     }
            // }
            if (mat) {
                if (!mat.animations) {
                    mat.animations = [];
                }
                let sameNameIndex = mat.animations.findIndex((v) => {
                    return v.name == animationName;
                });

                if (sameNameIndex >= 0) {
                    // No thing
                } else {
                    let babylonAnimation = new BABYLON.Animation(animationName, propPath, 1, animationType);
                    babylonAnimation.setKeys(keys.link);
                    (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);
                    mat.animations.push(babylonAnimation);
                    babylonAnimationGroup.addTargetedAnimation(babylonAnimation, mat);
                }
            } else {
                console.warn(`Can't Get Material While Create Animation.`);
            }
        });
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
}
function _color(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _mesh(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'emissiveColor', 'color', BABYLON.Animation.ANIMATIONTYPE_COLOR3);
    // return _material(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'emissiveColor', 'color', BABYLON.Animation.ANIMATIONTYPE_COLOR3);
}
function _alpha(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _mesh(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'alpha', 'alpha', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _material(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'alpha', 'alpha', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _alphaCutOff(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _mesh(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'alphaCutOff', 'alphaCutOff', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _material(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'alphaCutOff', 'alphaCutOff', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _maskCutoff(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _mesh(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskCutoff', 'maskCutoff', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _material(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskCutoff', 'maskCutoff', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}

// Texture About
function _texture(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup, texturePropPath: string, propPath: string, targetPath: string, animationType: number) {
    let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
    let materials = animeAbout[ETempNodeAnimationDataKey.Material];
    const animationName = `${babylonAnimationGroup.name}_channel${targetPath}`;

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
        materials.forEach((mat) => {
            if (mat) {
                const texture = mat[texturePropPath];
                let sameNameIndex = texture.animations.findIndex((v) => {
                    return v.name == animationName;
                });
                if (sameNameIndex >= 0) {
                    // No thing
                } else {
                    const babylonAnimation = new BABYLON.Animation(animationName, propPath, 1, animationType);
                    babylonAnimation.setKeys(keys.link);
                    (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);
                    texture.animations.push(babylonAnimation);
                    babylonAnimationGroup.addTargetedAnimation(babylonAnimation, texture);
                }
            } else {
                console.warn(`Can't Get Material While Create Animation.`);
            }
        });
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
}
function _uScale(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'uScale', 'uScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'uScale', 'uScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _vScale(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'vScale', 'vScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'vScale', 'vScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _uOffset(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'uOffset', 'uOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'uOffset', 'uOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _vOffset(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'vOffset', 'vOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuseTexture', 'vOffset', 'vOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _uScaleOp(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'uScale', 'uScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'uScale', 'uScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _vScaleOp(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'vScale', 'vScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'vScale', 'vScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _uOffsetOp(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'uOffset', 'uOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'uOffset', 'uOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _vOffsetOp(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'vOffset', 'vOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'opacityTexture', 'vOffset', 'vOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _uScaleM(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'uScale', 'uScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'uScale', 'uScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _vScaleM(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'vScale', 'vScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'vScale', 'vScale', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _uOffsetM(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'uOffset', 'uOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'uOffset', 'uOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _vOffsetM(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _meshTexture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'vOffset', 'vOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
    // return _texture(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'maskTexture', 'vOffset', 'vOffset', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}

// Camera About
function _ort(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    const targetPath = "ort";
    const animationType = BABYLON.Animation.ANIMATIONTYPE_FLOAT;

    const animationName = `${babylonAnimationGroup.name}_channel${targetPath}`;
    const wh = loader.babylonScene.getEngine().getScreenAspectRatio();

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
        let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
        let camera = animeAbout[ETempNodeAnimationDataKey.Camera];
        
        let setCameraAni = (a: string, b: number) => {
            const babylonAnimation = new BABYLON.Animation(animationName, a, 1, animationType);
            (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);
            const kk = JSON.parse(JSON.stringify(keys.link));
            for (let ii = 0; ii < kk.length; ii++) {
                kk[ii].value = kk[ii].value * b;
            }
            babylonAnimation.setKeys(kk);
            camera.animations.push(babylonAnimation);
            babylonAnimationGroup.addTargetedAnimation(babylonAnimation, camera);
        };
        setCameraAni('orthoLeft', wh * -1);
        setCameraAni('orthoRight', wh);
        setCameraAni('orthoBottom', -1);
        setCameraAni('orthoTop', 1);

        setCameraAni = undefined;
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
}
function _per(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {

    const targetPath = "per";
    const propPath = "fov";
    const animationType = BABYLON.Animation.ANIMATIONTYPE_FLOAT;

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
        const animationName = `${babylonAnimationGroup.name}_channel${targetPath}`;
        const babylonAnimation = new BABYLON.Animation(animationName, propPath, 1, animationType);
        babylonAnimation.setKeys(keys.link);
        (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);

        let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
        let camera = animeAbout[ETempNodeAnimationDataKey.Camera];

        camera.animations.push(babylonAnimation);
        babylonAnimationGroup.addTargetedAnimation(babylonAnimation, camera);
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
}

// Light About
function _light(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup, targetPath: string, propPath: string, animationType: number) {

    let animeAbout = loader.loaderRecord.nodeAnimationAbout.get(channel[1]);
    let target = animeAbout[ETempNodeAnimationDataKey.Light];

    let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, targetPath).then((keys) => {
            if (!target.animations) {
                target.animations = [];
            }

            const animationName = `${babylonAnimationGroup.name}_channel${targetPath}`;
            const babylonAnimation = new BABYLON.Animation(animationName, propPath, 1, animationType);
            babylonAnimation.setKeys(keys.link);
            (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);
            target.animations.push(babylonAnimation);
            babylonAnimationGroup.addTargetedAnimation(babylonAnimation, target);
    });
    loader.loaderRecord.animationLoaderList.push(promise);
    return promise;
}
function _intensity(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _light(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'intensity', 'intensity', BABYLON.Animation.ANIMATIONTYPE_FLOAT);
}
function _lightdiffuse(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    return _light(loader, context, animationContext, animation, channel, babylonAnimationGroup, 'diffuse', 'diffuse', BABYLON.Animation.ANIMATIONTYPE_COLOR3);
}

// 
function _weights(loader: GLTFLoader, context: string, animationContext: string, animation: IAnimation, channel: IAnimationChannel, babylonAnimationGroup: BABYLON.AnimationGroup) {
    // const targetNode: any = BABYLON.GLTF2.ArrayItem.Get(`${context}/target/node`, loader.gltf.nodes, channel[1]);

    // const buffer = BABYLON.GLTF2.ArrayItem.Get(`#/bufferViews/${(<any>animation).buffer}/buffer`, loader.gltf.buffers, (<any>animation).buffer);
    // const url = (<any>loader)._rootUrl + buffer.uri;
    // const url = (<any>loader)._rootUrl;

    // let targetPath = 'influence';
    // let animationType = BABYLON.Animation.ANIMATIONTYPE_FLOAT;
    
    // if (!(<OfflineProvider>loader.babylonScene.offlineProvider).loadAnimationKeys(`${url}_0`)) {
    //     let promise = loader._loadAnimationKeysAsync(context, animationContext, animation, channel, "").then((keys: Res<any, BABYLON.IAnimationKey[]>) => {
    //         // tslint:disable-next-line:no-non-null-assertion
    //         for (let targetIndex = 0; targetIndex < targetNode._numMorphTargets!; targetIndex++) {
    //             const animationName = `${babylonAnimationGroup.name}_channel${babylonAnimationGroup.targetedAnimations.length}`;
    //             const babylonAnimation = new BABYLON.Animation(animationName, targetPath, 1, animationType);
    //             let iKeys = (<OfflineProvider>loader.babylonScene.offlineProvider).loadAnimationKeys(`${url}_0`);
    //             if (!iKeys) {
    //                 let _Keys = keys.link.map((key) => ({
    //                     frame:      key.frame,
    //                     inTangent:  key.inTangent   ? key.inTangent[targetIndex]    : undefined,
    //                     value:      key.value[targetIndex],
    //                     outTangent: key.outTangent  ? key.outTangent[targetIndex]   : undefined
    //                 }));
    //                 let res = (<OfflineProvider>loader.babylonScene.offlineProvider).createAnimationKeys(`${url}_0`, _Keys);
    //                 babylonAnimation.setKeys(_Keys);
    //                 (<AnimationGroup>babylonAnimationGroup).piRecordRes(res);
    //                 (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);
    //             } else {
    //                 babylonAnimation.setKeys(iKeys.link);
    //                 (<AnimationGroup>babylonAnimationGroup).piRecordRes(iKeys);
    //                 (<AnimationGroup>babylonAnimationGroup).piRecordRes(keys);
    //             }
        
    //             (<any>loader)._forEachPrimitive(targetNode, (babylonMesh) => {
    //                 const morphTarget = babylonMesh.morphTargetManager?.getTarget(targetIndex);
    //                 const babylonAnimationClone = babylonAnimation.clone();
    //                 morphTarget.animations.push(babylonAnimationClone);
    //                 babylonAnimationGroup.addTargetedAnimation(babylonAnimationClone, morphTarget);
    //             });
    //         }
    //     });
    //     loader.loaderRecord.animationLoaders.push(promise);
    // } else {
    //     return Promise.resolve();
    // }
    
}