import { BABYLON } from '../babylon';

// tslint:disable-next-line:max-func-body-length
export const initInstancedMesh = () => {

    // 实例化优化 - 资源销毁处理
    if (BABYLON.InstancedMesh) {
        const old = BABYLON.InstancedMesh.prototype.dispose;
        BABYLON.InstancedMesh.prototype.dispose = function(doNotRecurse?: boolean, disposeMaterialAndTextures?: boolean) {
            old.bind(this)(doNotRecurse, false);
    
            const sourceMesh = this.sourceMesh;
            if (sourceMesh.instances.length == 0) {
                sourceMesh.dispose(doNotRecurse, true);
    
                const scene = this._scene;
    
                if (scene.metadata && scene.metadata.InstanceMeshMap && sourceMesh.metadata && sourceMesh.metadata.instanceID) {
                    scene.metadata.InstanceMeshMap.delete(sourceMesh.metadata.instanceID);
                }
            }
        }
    }
};