/**
 * 
 */
import { BABYLON } from '../babylon';
import { ExtensionTools, Res, ResTab } from '../../interface/index';

declare let module;
let logger;
ExtensionTools.RegistStartUp(() => { logger = ExtensionTools.Logger(module.name, "BABYLON"); });

// tslint:disable-next-line:max-func-body-length
export const initKTXTextureLoader = () => {
    
    // 压缩纹理应用
    if (BABYLON._KTXTextureLoader) {
        // BABYLON._DDSTextureLoader.prototype.canLoad = function(extension: string, textureFormatInUse: string, fallback: BABYLON.InternalTexture, isBase64: boolean, isBuffer: boolean): boolean {
        //     return extension.endsWith('.s3tc.ktx');
        // }
        BABYLON._KTXTextureLoader.prototype.canLoad = function(extension: string, mimeType?: string): boolean {
            return extension.endsWith('.ktx');
        }
        // BABYLON._KTXTextureLoader.prototype.transformUrl = function(rootUrl: string, textureFormatInUse: string): string {
        //     // alert(rootUrl);
        //     return rootUrl;
        // }
        BABYLON._KTXTextureLoader.prototype.loadData = function (data, texture, callback) {
            // Need to invert vScale as invertY via UNPACK_FLIP_Y_WEBGL is not supported by compressed texture
            texture._invertVScale = !!texture.invertY;
            var ktx = new BABYLON.KhronosTextureContainer(data, 1);
            callback(ktx.pixelWidth, ktx.pixelHeight, false, true, function () {
                ktx.uploadLevels(texture, texture.generateMipMaps);
            }, ktx.isInvalid);
        };
        console.warn("BABYLON._KTXTextureLoader 已引入,可以加载压缩纹理");
    } else {
        console.warn("BABYLON._KTXTextureLoader 未引入,不能加载压缩纹理");
    }
};