import { BABYLON } from '../babylon';

// tslint:disable-next-line:max-func-body-length
export const initMesh = () => {

    //#region cellId Animation
    Object.defineProperty(BABYLON.Mesh.prototype, '_cellId', {
        enumerable: true,
        configurable: true,
        writable: true,
        value: 0
    });
    
    Object.defineProperty(BABYLON.Mesh.prototype, 'cellWidth', {
        enumerable: true,
        configurable: true,
        writable: true,
        value: 1
    });
    
    Object.defineProperty(BABYLON.Mesh.prototype, 'cellHeight', {
        enumerable: true,
        configurable: true,
        writable: true,
        value: 1
    });

    Object.defineProperty(
        BABYLON.Mesh.prototype,
        'cellId',
        {
            get() : number {
                return this._cellId;
            },
            set(v: number) {
                this._cellId = Math.floor(v) % (this.cellHeight * this.cellWidth);
                const mesh: BABYLON.Mesh = this;
                const mat = <BABYLON.StandardMaterial>mesh.material;
                const mat2 = <BABYLON.PBRMaterial>mesh.material;
                
                let tex: BABYLON.Texture = null;
                
                if (mat && mat.diffuseTexture) {
                    tex = <BABYLON.Texture>mat.diffuseTexture;
                }

                if (mat2 && mat2.albedoTexture) {
                    tex = <BABYLON.Texture>mat2.albedoTexture;
                }

                if (tex) {
                    tex.uScale  = 1.0 / (this.cellWidth || 1);
                    tex.vScale  = 1.0 / (this.cellHeight || 1);
                    tex.uOffset = (this._cellId % this.cellWidth) / this.cellWidth;
                    tex.vOffset = 1.0 - (Math.floor(this._cellId / this.cellWidth) + 1) / this.cellHeight;
                }
            }
        }
    )
    //#endregion
};