import { BABYLON } from '../babylon';

// tslint:disable-next-line:max-func-body-length
export const initScene = () => {

    BABYLON.Scene.prototype.useDelayedTextureLoading = true;
    
    BABYLON.Scene.prototype._loadFile = function (url, onSuccess, onProgress, useOfflineSupport, useArrayBuffer, onError) {
        var _this = this;
        var request = BABYLON.FileTools.LoadFile(url, onSuccess, onProgress, this.offlineProvider, useArrayBuffer, onError);
        this._activeRequests.push(request);
        request.onCompleteObservable.add(function (request) {
            _this._activeRequests.splice(_this._activeRequests.indexOf(request), 1);
        });
        return request;
    }
};