import { ExtensionTools } from "../interface/index";


export class TimeoutPool {
    private static Unique: number = Number.MIN_SAFE_INTEGER;
    private static pool: Array<[number, number, number, Function]> = [];
    private static record: Set<number> = new Set();
    private static time: number = Date.now();
    public static setTimeout(func: Function, delayms: number) {
        let handler = TimeoutPool.Unique++;
        TimeoutPool.pool.push([TimeoutPool.time + delayms, delayms, handler, func]);
        TimeoutPool.record.add(handler);
        return handler;
    }
    public static clearTimeout(handler: number) {
        TimeoutPool.record.delete(handler);
    }
    public static _frameCall() {
        TimeoutPool.time = Date.now();
        TimeoutPool.pool.sort(function(a, b) { return b[0] - a[0] });
        let item = TimeoutPool.pool.pop();
        while (item != undefined) {
            if (TimeoutPool.record.has(item[2])) {
                if (item[0] <= TimeoutPool.time) {
                    try {
                        item[3]();
                    } catch (err) {
                        console.error(err);
                    }
                } else {
                    TimeoutPool.pool.push(item);
                    break;
                }
            }
            item = TimeoutPool.pool.pop();
        }
    }
    public static Init() {
        ExtensionTools.setPermanentBefore(TimeoutPool._frameCall);
    }
}
