# 动画切换方案
* 接口: setAnim()
    + animName:     转换到哪个动画;
    + isLoop:       动画是否循环;
    + endCall?:     动画结束时的回调;
    + startCall?:   动画开始时的回调;

* PS: 所有动画切换均为 一个动画 切换到 另一个动画, 不同动画组合的效果应当在切换前先组装出目标动画

* 应用情况
    + 优先级最高
        - workWithAnimationGroupChange 为 true 时, 通过 AnimationGroupChange 模块控制, 该情况下当前动画完全结束才会切换到目标动画
        - animName: 为 AnimationGroupChangeCfg 配置中 AnimationGroupChangeInfo 项的名称
        - 动画分类
            * 循环动画 > 别名: 状态动画
            * 一次性动画 > 别名: 动作动画
        - 规则 
            - 源动画的末帧 与 目标动画首帧相同 - 制作要求
            - 动作动画一定是从状态动画或者自身切换而来
            - 状态动画播放到末帧才能切换到动作动画,  同样 动作动画播放到末帧才能切换到状态动画
            - 切换时的 源动画 与 目标动画 的关系由配置决定,  不存在配置表未声明的切换过程
            - 切换过程的时长可控
            - 每次逻辑控制的切换命令限制,  只能一次命令从 A 到 B, 另一次命令 从 B 到 C, 不能一次命令从 A 到 B 再 到 C
            - 动作动画有结束响应

    + 优先稍低
        - changeAnimEnableBlending 为 true 时,自动对 当前动画与目标动画混合来平滑过渡
        - 这个情况可以修改模型 changeAnimBlendSpeed 混合过渡的速度
        - 动画开始时的回调 无效, 因为调用时即为动画开始,项目逻辑自己运行即可

    + 优先级再低
        - 没有特殊设置,这个情况下 会立即停止当前动画，切换为目标动画
        - 动画开始时的回调 无效, 因为调用时即为动画开始,项目逻辑自己运行即可